#' respR: Analyse, convert, and automate respirometry-related data.
#'
#' respR is an R package that consists of a collection of functions that provide
#' a structured, reproducible workflow for the analysis of respirometry-related data. 
#' Focus is placed on ease-of-use.
#'
#' Works with closed, open tank, intermittent flow, and flowthrough respirometry data. 
#' Main functions allow determination of VO2, MO2, MO2min, MO2max, and PCrit. 
#' Functions for background corrections and unit conversions are included.
#'
#' @author Januar Harianto & Nicholas Carey
#' @docType package
#' @name respR
